//+------------------------------------------------------------------+
//|                                                 RSIFilter_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -2
#property indicator_maximum 2
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_color2 SkyBlue
//---- input parameters
extern int PeriodRSI=14;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double TrBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   SetIndexBuffer(0,UpBuffer); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"UpTrend");
   SetIndexBuffer(1,DnBuffer); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"DownTrend");
   SetIndexBuffer(2,TrBuffer); SetIndexEmptyValue(2,0);

   IndicatorShortName("RSI Filter("+PeriodRSI+")");
   SetIndexDrawBegin(0,PeriodRSI);
   SetIndexDrawBegin(1,PeriodRSI);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    countedBars = IndicatorCounted();
   int    i,limit;

   if (countedBars<0) return(-1);
   if (countedBars>0) countedBars--;
         limit = Bars-countedBars;
   
   //
   //
   //
   //
   //
   
   
   for(i = limit; i >=0; i--)
   {
      TrBuffer[i] = TrBuffer[i+1];
      DnBuffer[i] = EMPTY_VALUE;
      UpBuffer[i] = EMPTY_VALUE;
     
      //
      //
      //
      //
      //
           
      double RSI0=iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i);
         if (RSI0>70) TrBuffer[i] =  1; 
         if (RSI0<30) TrBuffer[i] = -1;
	  
         if (TrBuffer[i]>0 && RSI0 > 40) UpBuffer[i] =  1.0;
         if (TrBuffer[i]<0 && RSI0 < 60) DnBuffer[i] = -1.0;
	}
	return(0);	
 }

